<?php
/**
 * JP_For_TwentyTwentyOne_TOC class.
 *
 * @since 1.4.0
 */
class JP_For_TwentyTwentyOne_TOC {

	public static function shortcode_toc( $atts ) {
		global $post;

		if ( ! isset( $post ) ) {
			return '';
		}

		$atts = shortcode_atts( array(
			'id' => '',
			'class' => 'toc',
			'title' => __( 'Table of contents', 'jp-for-twentytwentyone' ),
			'toggle' => true,
			'opentext' => __( 'Open', 'jp-for-twentytwentyone' ),
			'closetext' => __( 'Close', 'jp-for-twentytwentyone' ),
			'initialview' => true,
			'showcount' => 2,
			'depth' => 0,
			'toplevel' => 2,
		), $atts, 'toc' );

		$atts['toggle'] = ( false !== $atts['toggle'] && 'false' !== $atts['toggle'] ) ? true : false;
		$atts['initialview'] = ( false !== $atts['initialview'] && 'false' !== $atts['initialview'] ) ? true : false;

		$content = $post->post_content;

		$headers = array();
		preg_match_all( '/<([hH][1-6]).*?>(.*?)<\/[hH][1-6].*?>/u', $content, $headers );
		$header_count = count( $headers[0] );
		$counter = 0;
		$current_depth = 0;
		$prev_depth = 0;
		$top_level = min( max( intval( $atts['toplevel'] ), 1), 6 );
		$atts['toplevel'] = $top_level;
		$max_depth = ( ( 0 === $atts['depth'] ) ? 6 : intval( $atts['depth'] ) );	// 表示する階層数

		$toc_list = '';
		for ( $i = 0; $i < $header_count; $i++ ) {
			$depth = 0;
			switch ( strtolower( $headers[1][$i] ) ) {
				case 'h1': $depth = 1 - $top_level + 1; break;
				case 'h2': $depth = 2 - $top_level + 1; break;
				case 'h3': $depth = 3 - $top_level + 1; break;
				case 'h4': $depth = 4 - $top_level + 1; break;
				case 'h5': $depth = 5 - $top_level + 1; break;
				case 'h6': $depth = 6 - $top_level + 1; break;
			}
			if ( $depth >= 1 && $depth <= $max_depth ) {
				if ( $current_depth == $depth ) {
					$toc_list .= '</li>';
				}
				while ( $current_depth > $depth ) {
					$toc_list .= '</li></ul>';
					$current_depth--;
				}
				if ( $current_depth != $prev_depth ) {
					$toc_list .= '</li>';
				}
				if ( $current_depth < $depth ) {
					$attr = '';
					if ( $current_depth == 0 ) {
						$attr .= ' class="toc-list"';
						$attr .= ! $atts['initialview'] ? ' hidden=""' : '';
					}
					$toc_list .= "<ul{$attr}>";
					$current_depth++;
				}
				$toc_list .= '<li><a href="#toc' . ($i + 1) . '">' . $headers[2][$i] . '</a>';
				$prev_depth = $depth;
				$counter++;
			}
		}
		while ( $current_depth >= 1 ) {
			$toc_list .= '</li></ul>';
			$current_depth--;
		}

		$html = '';
		if ( $counter >= $atts['showcount'] ) {
			$toggle = '';
			if ( $atts['toggle'] ) {
				$toggle = ' <span class="toc-toggle">[<a class="internal" href="javascript:void(0);">' . ( $atts['initialview'] ? $atts['closetext'] : $atts['opentext'] ) . '</a>]</span>';
			}

			$html .= '<div' . ( $atts['id'] != '' ? ' id="' . $atts['id'] . '"' : '' ) . ' class="' . $atts['class'] . '">';
			$html .= '<p class="toc-title">' . $atts['title'] . $toggle . '</p>';
			$html .= $toc_list;
			$html .= '</div>' . "\n";
		}

		return $html;
	}
}
